;;
;;		Copyright  1994 Roger Corman.  All rights reserved.
;;
;
;		Lisp standard functions and macros to be loaded at startup.
;

(defun copyright ()
	"Copyright  1994 Roger Corman")

(print (copyright))
(print "Loading PowerLisp standard library...")

(make-package :compiler)

(print "this is a test")	

;; this is only needed to load the standard library,
;; which then rolls this functionality into 'load'.
(defun load-binary (filename)
	(let*
		((loaded 0)
		 (stream (open filename))
		 (*package* *package*)			;; bind these to themselves
		 (*readtable* *readtable*)
		 (*standard-output* *standard-output*))
		 
		(do* ((expr t) (symbol-table (make-array 500)))
			((null expr)(close stream) loaded)
			(setq expr (%read-code-from-stream stream symbol-table))
			(if expr
				(let ((result (funcall expr)))
					(setq loaded (+ 1 loaded)))))))

(if (probe-file ":library:cl.fasl")
	(progn 
		(load-binary ":library:cl.fasl")
		(print "Standard Library (binary) loaded."))
	(if (probe-file ":library:cl.lisp")
		(progn
			(load ":library:cl.lisp")
			(print "Standard Library loaded."))
		(print "Could not find Standard Library.")))

(print "this is another test")	
(setq *prompt* #'prompt)

; garbage collect
;(gc)














